#include <bits/stdc++.h>
using namespace std;
#define int long long
const long double inf = 1e18;
struct dot {
    long double x, y;
};
struct line {
    long double k, b;
};
long double dist(dot a, dot b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}
line new_line(dot a, dot b) {
    long double k, b1;
    if (b.x == a.x) k = 0;
    else k = (b.y - a.y) / (b.x - a.x);
    b1 = a.y - k * a.x;
    return {k, b1};
}
dot inter(line m, line n) {
    dot ans;
    ans.x = (n.b - m.b) / (m.k - n.k);
    ans.y = m.k * ans.x + m.b;
    return ans;
}
void solve() {
    int n;
    cin >> n;
    vector <dot> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;
    if (n == 2) {
        cout << fixed << dist(a[0], a[1]);
        exit(0);
    }
    vector <int> p(n);
    iota(p.begin(), p.end(), 0);
    int f = 1;
    for (int i = 2; i <= n; i++) f *= i;
    long double Ans = inf, ans = 0;
    for (int i = 0; i < f; i++) {
        if (p[n - 1] > p[0]) {
            for (int j = 0; j < n - 1; j++) {
                ans = 0;
                long double k = new_line(a[p[j]], a[p[j + 1]]).k;
                for (int ij = 0; ij < n - 1; ij++) {
                    dot z;
                    if (k == 0) {
                        long double b1 = a[p[ij]].y - a[p[ij]].x * k;
                        long double b2 = a[p[ij + 1]].y - a[p[ij + 1]].x * k;
                        dot z = inter({k, b1}, {k, b2});
                    }
                    else {
                        long double b1 = a[p[ij]].y - a[p[ij]].x * k;
                        long double b2 = a[p[ij + 1]].y - a[p[ij + 1]].x * (-1/k);
                        dot z = inter({k, b1}, {(-1)/k, b2});
                    }
                    ans += dist(a[p[ij]], z) + dist(a[p[ij + 1]], z);
                    //cout <<fixed<< z.x << ' ' << z.y << ' ' << b1 << ' ' << b2 << ' ' << ans << endl;
                }
                //cout <<fixed<< ans << "\n\n";
                Ans = min(Ans, ans);
            }
        }
        next_permutation(p.begin(), p.end());
    }
    cout << fixed << setprecision(10) << Ans;
}
signed main() {
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
